<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

require_once("security.php");

class elt {
    var $datas;
    function display($scope='one',$base=null) {
        if (($this->datas['type'] == 'link') and ($base and ($scope=='all'))){
            $base->display_elt($this->datas['linkid'],$scope,$base);
        } else {
            foreach($this->datas as $key=>$data){
                echo "$key : ".$data." ";
            }
        }
        echo "<br>";
    }
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'elt' );
        foreach($this->datas as $key=>$data){
          if (($data != '--') and ($data != ''))
                $node->set_attribute($key,$data);
        }
        $curelt->append_child($node);
    }
    function express($base=null) {
        $result=array();
        if (($this->datas['type'] == 'link')){
            $base->express_elt($this->datas['linkid'],'all',$base);
        } else {
            foreach($this->datas as $key=>$data){
                $result[$key]=$data;
            }
        }
        return($result);
    }
    function elt($data,$type='xml',$id=0){
      if ($type == 'xml')
      {
        $struct=$data->attributes();
        foreach($struct as $attr=>$value){
            foreach($value as $mer=>$ter){
                if ( preg_match('/^name$/',$mer) ){
                    #echo "found name $ter<br>";
                    $nam=$ter;
                } elseif (preg_match('/^value$/',$mer)  ){
                    $val=$ter;
                }
            }
            $this->datas[$nam]=$val;
        }
      }else{
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $data["ID"]=$id;
        $this->datas=$data;
      }
    }
    function get_id(){
      return $this->datas["ID"];
    }
#    function list_tab()
#    {
#        foreach ($this->elts as $elt){
#          if ($elt->name!=''){
#            $result{$elt->ID} = ($elt->name);
#          }else{
#            $result{$elt->ID} = $elt->ID;
#          }
#        }
#      return $result;
#    }
    function get_obj()
    {
      $result=array();
      foreach ($this->datas as $key=>$obj)
      {
        $result{$key}=$obj;
      }
      return $result;
    }
}

#class ipv4_elt extends elt {
#    var $net;
#    var $dport;
#}

class set {
    var $elts;
}

class obj_set extends set {
    function display($scope='one'){
        foreach ($this->elts as $key=>$elt){
            printf("%d : ",$key);
            $elt->display($scope,$this);
            echo "<br>";
        }
    }
    function xmldump($xml,$curelt){
        # TODO : use a DTD to do that ?
         $tagname = preg_replace('/s$/','', $curelt->tagname);
         foreach ($this->elts as $key=>$elt){
               $node = $xml->create_element($tagname);
#               $node->set_attribute('linkid',$key);
               $elt->xmldump($xml,$node);
               $curelt->append_child($node);
         }
    }
    function display_elt($elt,$scope="one"){
        $this->elts[$elt]->display($scope,$base=$this);
    }
    function express_elt($elt,$scope="one"){
        $this->elts[$elt]->express($scope,$base=$this);
    }
    function obj_set($hash){
        $this->elts=$hash;
    }
    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function &get_elt_by_id($id){
	foreach ($this->elts as $index => $elt){
		if ($elt->ID == $id){
			return $this->elts[$index];
		}
	}
	return null;
    }
    function replace_elt($index,$elt){
        unset ($this->elts[$index]);
        $this->elts[$index]=$elt;
    }
    function del_elt($index){
        unset ($this->elts[$index]);
    }
    function add_elt($elt){
        $this->elts[$elt->get_id()]=$elt;
    }
    function get_max_elt_id(){
      $max=0;
      if (!isset($this->elts))
        return(0);
      foreach (($this->elts) as $elts){
        $local = $elts->get_max_elt_id();
        if ($local>$max)
          $max = $local;
      }
      return $max;
    }
    function new_elt_id(){
      return $this->get_max_elt_id() + 1;
    }
    function get_max_id(){
      $max=0;
      foreach (($this->elts) as $elts){
        $local=$elts->get_id();
        if ($local>$max)
          $max=$local;
      }
      return $max;
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function list_tab()
    {
        foreach ($this->elts as $elt){
          if ($elt->name!=''){
            $result{$elt->ID} = ($elt->name);
          }else{
            $result{$elt->ID} = $elt->ID;
          }
        }
      return $result;
    }
    function ordered_list_tab()
    {
      $ids=array();
      foreach ($this->elts as $elt){
        array_push($ids,$elt->ID);
      }
      sort($ids);

      foreach ($ids as $id){
        foreach ($this->elts as $elt){
          if ($id == $elt->ID){
            if ($elt->name!=''){
              $result{$elt->ID} = ($elt->name);
            }else{
              $result{$elt->ID} = $elt->ID;
            }
          }
        }
      }
      return $result;
    }
    function nb_obj(){
      $result=0;
      foreach ($this->elts as $elt){
        $result++;
      }
      return($result);
    }
}

class elt_set extends set {
    var $name;
    var $operator;
    var $ID;
    function display($scope='one',$base=null) {
        echo $this->name."<br>";
        echo "Logical op: ".$this->operator."<br>";
        foreach ($this->elts as $key=>$elt){
            echo "$key : ";
            $elt->display($scope,$base);
        }
    }
    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        $node->set_attribute('op',$this->operator);
        $node->set_attribute('ID',$this->ID);
        foreach ($this->elts as $elt){
                $elt->xmldump($xml,$node);
        }
    }
    function elt_set($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->operator=$ress['operator'];
        $this->name=$ress['name'];
      }else{
        $this->operator=$ress->get_attribute('op');
        $this->name=$ress->get_attribute('name');
        $this->ID=$ress->get_attribute('ID');
      }
    }
    function add_elt($elt){
        $this->elts[$elt->get_id()]=$elt;
    }
    function del_elt($index){
        #array_splice($this->elts,$index,1);
        unset ($this->elts[$index]);
    }
    function modify_param($param,$value){
        if ($param == 'ID'){
          return(-1);
        }
        if (($param=='name') or ($param=='operator')){
          $this->$param=$value;
          return(0);
        }
        return(-1);
    }
    
    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function get_id(){
      return($this->ID);
    }
    function get_max_elt_id(){
        $max=0;
        foreach ($this->elts as $elt){
            $local=$elt->get_id();
            if ($local>$max)
              $max=$local;
        }
        return $max;
    }
    function list_tab()
    {
        foreach ($this->elts as $elt){
          if ($elt->datas['name']!=''){
            $result{$elt->datas['ID']} = ($elt->datas['name']);
          }else{
            $result{$elt->datas['ID']} = $elt->datas['ID'];
          }
        }
      return $result;
    }
    function get_obj()
    {
      foreach ($this as $key=>$obj)
      {
#Skip elts, that contains stuff from subelements
        if ($key=='elts')
          continue;
        $result{$key}=$obj;
      }
      return $result;
    }
}

class ressource extends elt_set {
    function ressource($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
    function express($ress){
        foreach($ress->get_elements_by_tagname("elt") as $resselt){
          $result=$resselt->express;
        }
    }
}

class subject extends elt_set {
    function subject($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class protocol extends elt_set {
    function protocol($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class acl {
  var $name;
  var $from;
  var $to;
  var $proto;
  var $ID;
  var $decision;
    function acl($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        $this->from=$ress['from'];
        if (($ress['proto']!=0) and ($ress['proto']!=''))
          $this->proto=$ress['proto'];
        $this->to=$ress['to'];
        $this->decision=$ress['decision'];
      }else{
        $this->name=$ress->get_attribute('name');
        $this->from=$ress->get_attribute('from');
        $this->to=$ress->get_attribute('to');
        if (($ress->get_attribute('proto')) and ($ress->get_attribute('proto')!=''))
          $this->proto=$ress->get_attribute('proto');
        $this->ID=$ress->get_attribute('ID');
        $this->decision=$ress->get_attribute('decision');
      }
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        $node->set_attribute('from',$this->from);
        $node->set_attribute('to',$this->to);
        if ($this->proto!='')
          $node->set_attribute('proto',$this->proto);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('decision',$this->decision);
    }

    function display($scope='one',$base=null) {
        echo "$this->name : from $this->from to $this->to protocol $this->proto decision $this->decision<br>"; 
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function clone(){
      $t=array();
      $t['name']=$this->name;
      $t['proto']=$this->proto;
      $t['from']=$this->from;
      $t['to']=$this->to;
      $t['ID']=$this->ID;
      $t['decision']=$this->decision;
      return new acl($t,$type='toto',$id=$t['ID']);
    }
}



class policy extends elt {
    /* 3 hashs containing needed informations */
    var $ressources;
    var $subjects;
    var $protocols;
    var $acls;

    /* creator from xml file */
    function policy($file){
        if (!$dom = domxml_open_file($file)) {
            echo "Error while parsing the document\n";
            exit;
        }
        $root = $dom->document_element();
        $ressources = $root->get_elements_by_tagname("ressources");
        $ressources=$ressources[0];
        /* iter on ressource */
        $ressource_list=$ressources->get_elements_by_tagname("ressource");
        foreach ($ressource_list as $ress){
            $newress=new ressource($ress);
            $id=$ress->get_attribute("ID");
            $hash_ress[$id]=$newress;
        }

        $this->ressources=new obj_set($hash_ress);

        $subjects = $root->get_elements_by_tagname("subjects");
        $subjects=$subjects[0];
        $subject_list=$subjects->get_elements_by_tagname("subject");
        foreach ($subject_list as $sub){
            $newsub=new subject($sub);
            $id=$sub->get_attribute("ID");
            $hash_sub[$id]=$newsub;
        }

        $this->subjects=new obj_set($hash_sub);

        $protocols = $root->get_elements_by_tagname("protocols");
        $protocols=$protocols[0];
        $protocol_list=$protocols->get_elements_by_tagname("protocol");
        foreach ($protocol_list as $pro){
            $newprot=new protocol($pro);
            $id=$pro->get_attribute("ID");
            $hash_proto[$id]=$newprot;
        }

        $this->protocols=new obj_set($hash_proto);

        $acls = $root->get_elements_by_tagname("acls");
        $acls=$acls[0];
        $acl_list=$acls->get_elements_by_tagname("acl");
        foreach ($acl_list as $sub){
            $newsub=new acl($sub);
            $id=$sub->get_attribute("ID");
            $hash_acls[$id]=$newsub;
        }
        $this->acls=new obj_set($hash_acls);
    }
    function xmldump($filename=''){
        # create new xml document
        $xml = domxml_new_doc( '1.0' );
        $root = $xml->create_element('policy');
        $new_root = $xml->append_child($root);
        #ressources
        $node = $xml->create_element( 'ressources' );
        $newnode = $new_root->append_child($node);
        $this->ressources->xmldump($xml,$newnode);
        #subjects
        $node = $xml->create_element( 'subjects' );
        $newnode = $new_root->append_child($node);
        $this->subjects->xmldump($xml,$newnode);
        #protocols
        $node = $xml->create_element( 'protocols' );
        $newnode = $new_root->append_child($node);
        $this->protocols->xmldump($xml,$newnode);
        #acls
        $node = $xml->create_element( 'acls' );
        $newnode = $new_root->append_child($node);
        $this->acls->xmldump($xml,$newnode);
        # dump xml document
        if ($filename=='')
        {
          echo $xml->dump_mem( true, 'UTF-8' ) ;
          return(1);
        }else{
          return($xml->dump_file($filename,false,true));
        }
    }
}

function check_file_name($filename){
#We're not accepting file names containing a slah or two consequent dots.
  if ((preg_match('/\//',$filename)) or (preg_match('/\.\./',$filename)))
  {
    echo "There is a problem with the provided file name";
    return(1);
  }
  return(0);
}

function read_file($filename){
  if (check_file_name($filename))
    return(-1);
  global $datadir;
  $expolicy= new policy($datadir.'/'.$filename);
  return $expolicy;
}

function save_file($expolicy,$filename=''){
  global $datadir;
  if (check_file_name($filename))
    return(-1);
  if ($filename==''){
    return($expolicy->xmldump());
  }
  else
  {
    return($expolicy->xmldump($datadir.'/'.$filename));
  }
}

function del_file($filename=''){
  global $datadir;
  if (check_file_name($filename))
    return(-1);
  if ($filename==''){
    return(0);
  }
  return(unlink($datadir.'/'.$filename));
}

function cmp_file($elt1, $elt2){
 if ($elt1["mtime"] == $elt2["mtime"])
 {
   return 0;
 }
 return ($elt2["mtime"] > $elt1["mtime"]) ? 1: -1;
}

function file_list(){
 global $datadir;
 $files = array();  
 $res = array();
 $dir = opendir($datadir);  
 if (! $dir)
 {
    echo "Could not open directory \$datadir! Please check your configuration";
    return(-1);
 }
 while(($file = readdir($dir)) !== false)  
 {  
  if($file !== '.' && $file !== '..' && !is_dir($file))  
  {  
    clearstatcache();
    $mtime = stat($datadir."/".$file);
    $mtime = $mtime["mtime"];
    $files[] = array("file" => $file, "mtime" => $mtime);  
  }  
 }  
 closedir($dir);  
 usort($files,"cmp_file");
 foreach($files as $elt)
 {
   $res[] = $elt["file"];
 }
 return($res);
}

function max_elt($array)
{
  $max=0;
  if (isset($array) and ($array!=''))
    foreach ($array as $elt)
    {
      $local=$elt->get_ID();
      if ($local>$max)
        $max=$local;
    }
  return($max);
}

function print_console($msg)
{
  print "<div class=\"console\">$msg</div>";
}

function print_consolebis($msg)
{
  print "<div class=\"console2\">$msg</div>";
}
$log_console='';
function add_log($s)
{
  global $log_console;
  $log_console .= $s."<br />";
}

function print_console2()
{
  global $log_console;
  if($log_console!=""){
    print_console($log_console);
  }
}

function begin_content_detail(){
  echo '<div class="content">';
  print_console2();
}

function end_content_detail(){
  //print_console2();
  echo '</div> <!-- content -->';
}

function end_page(){
  include('footer.php');
}

function log_and_exit($exit_code){
  begin_content_detail();
  end_content_detail();
  end_page();
  exit($exit_code);
}
