<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

require("include/function.php");
require("include/config.php");
require("include/messages.php");

$title='index';
$input=$_REQUEST['input_file'];
$generate=$_REQUEST['generate'];
$used_file=$_REQUEST['used_file'];
$reload_rules=$_REQUEST['reload_rules'];
$reload_rules_type=$_REQUEST['reload_rules_type'];
if (isset($input))
{
  session_start();
  $document=read_file($input);
  $_SESSION['document']=serialize($document);
  add_log($input.$mess_index_file_was_loaded);
}
else{ #We don't read and write at the same time, do we?
  $output=$_GET['output_file'];
  if (isset($output))
  {
    session_start();
    $document=unserialize($_SESSION['document']);
    if ($output=='')
      print "<html><a href=\"index.php\">$gal_back_to_index</a><xmp>\n";
    $result=save_file($document,$output);
    if ($output=='')
    {
      print "</xmp>\n";
      print "</html>\n";
      exit(0);
    }
    if($result)
    {
      if ($output!='')
        add_log("$datadir/$output".$mess_index_file_was_saved);
    }else{
      add_log($mess_index_error_while_saving."$datadir/$output");
    }
  }else{ #We don't write and delete at the same time, do we?
    $delete=$_GET['delete_file'];
    if (isset($delete))
    {
      if(del_file($delete))
      {
        add_log("$datadir/$delete".$mess_index_file_was_deleted);
      }else{
        add_log($mess_index_error_while_deleting."$datadir/$delete");
      }
    }else{
      $forget=$_REQUEST['forget'];
      session_start();
      if(isset($forget) and ($forget==1) and (isset($used_file)) and (preg_match('^/a-zA-Z0-9\.\-\_/$',$used_file)) and (!preg_match('/\.\./',$used_file)) and (file_exists($datadir.$used_file)))
      {
        add_log($mess_index_forget_all);
        $document=array();
        $_SESSION['document']=serialize($document);
        $_SESSION['floating_elts']=serialize($document);
      } else {
        if ((isset($generate)) and ($generate==1))
        {
#          add_log($nupyf_command." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file.">".$rules_dir."/".$nufw_rules_file);
#          add_log($nupyf_command." --std ".$rules_dir."/".$std_rules_file." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file);
          $nufw_cmd=$nupyf_command." --ulog --conf ".$network_desc_dir."/".$nupyf_conf_file." --dumpldap ".$rules_dir."/".$nupyf_ldap_file." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file.">".$rules_dir."/".$nufw_rules_file.".tmp";
	  #add_log($nufw_cmd);
          system($nufw_cmd,$result1);
          system($nupyf_command." --ulog --std ".$rules_dir."/".$std_rules_file.".tmp ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file,$result2);
          if (($result1!=0) or ($result2!=0))
            add_log($mess_error);
          else
          {
            rename($rules_dir."/".$nufw_rules_file.".tmp",$rules_dir."/".$nufw_rules_file);
            rename($rules_dir."/".$std_rules_file.".tmp",$rules_dir."/".$std_rules_file);
            add_log($mess_ok);
          }
        }else{
          if ((isset($reload_rules)) and ($reload_rules==1))
          {
            if (isset($reload_rules_type))
            {
#            add_log("$sudo_command /etc/init.d/init-firewall start 2>&1 > $datadir/problems_log");
              $farg = $reload_rules_type == 'standard'? 'nonufw': 'start';
              #print "$sudo_command /etc/init.d/init-firewall $farg 2>&1";
              system("$sudo_command /etc/init.d/init-firewall $farg 2>&1 > $logdir/problems_log",$result);
            
              if ($result==0)
              {
                add_log($mess_reload_rules_ok);
              }else{
                add_log($mess_reload_rules_nok);
              }
            }
          } 
        }
      }
    }
  }
}

$files=file_list();
require("include/headers.php");
?>
<div class="menu">
<?php
print "<h3>$mess_index_load_conf_from_file</h3>";
?>
<form action="index.php" method=POST>
 <select name="input_file">
<?php
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
print "</select>";
print "<INPUT type=\"submit\" value=\"$mess_index_button_open\" class=\"button\">";
print "</form>";
print "<h3>$mess_index_save_conf_to_file</h3>";

echo "<form><select name=\"output_file\">";
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
echo " </select>";
print " <INPUT type=\"submit\" value=\"$mess_index_button_overwrite\" class=\"button\">";
echo "</form>";
echo "<form>";
echo "  <input type=\"text\" name=\"output_file\">";
print "  <input type=\"submit\" value=\"".$mess_index_button_new."\" class=\"button\">";
echo "</form>";
echo "<form>";
echo "  <input type=hidden name=\"output_file\" value=\"\">";
print "  <input type=\"submit\" value=\"$mess_index_button_dump_on_screen\" class=\"button\">";
echo "</form>";

print "<h3>$mess_index_delete_a_saved_file</h3>";
?>
<form>
 <select name="delete_file">
<?php
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
?>
 </select>
<?php
print "<INPUT type=\"submit\" value=\"$mess_index_button_delete\" class=\"button\">";
echo "</form>";

print "<h3>$mess_index_forget_this_session</h3>";
print $mess_index_all_changes_discarded;
?>
<br><form action="index.php" method=POST>
<input type="hidden" name="forget" value="1">
<?php
print "<input type=\"submit\" value=\"$mess_index_button_forget_all\" class=\"button\">";
?>
</form>

<?php
print "<h3>$mess_title_rules</h3>";
print "<form action=\"index.php\" method=POST>";
print "  <input type=\"submit\" value=\"$mess_index_generate_rules\" class=\"button\">";
print "  <input type=\"hidden\" name=generate value=1>";
print " <select name=\"used_file\">";
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
print "</select>";
?>
</form>
<form>

<?php
print "<h3>$mess_reload_rules</h3>";
print "<select name=\"reload_rules_type\" >";
print " <option>nufw</option>";
print " <option>standard</option>";
print "</select>";
print "<input type=\"submit\" value=\"$mess_reload_rules\" class=\"button\">";
print "<input type=\"hidden\" value=\"1\" name=\"reload_rules\">";
?>
</form>
</div>
<?php
begin_content_detail();
end_content_detail();
require("include/footer.php");
?>
