#! /bin/sh

# This the install script for nuface
# see http://www.inl.fr/nuface.html for more information

fw_script=./scripts/init-firewall
BASEDIR=/etc/network/firewall
nupyf_conf=scripts/nupyf.conf
REAL_DYNDIR=/var/local/nufw/dyn

#user the web server is running as
www_user=www-data

nuface_datadir=/var/local/nuface
nuface_logdir=/var/local/nuface-logs
nuface_installdir=/var/www/
acls_ex=acls.xml
desc_ex=desc.xml

mkdir_print(){
echo -n $1
mkdir -p $1 && echo " done."
}

usage(){
echo 'install.sh [-h] [-i nuface_installdir]'
}

if [ -n "$1" ] ; then
  if [ "$1" == '-h' ] ; then
    usage;
    exit 0;
  fi
fi


echo "Creating directories:"
#create directories
mkdir_print $BASEDIR
mkdir_print $BASEDIR/desc
mkdir_print $REAL_DYNDIR
mkdir_print $nuface_datadir
mkdir_print $nuface_logdir

echo -n "linking $BASEDIR/dyn to $REAL_DYNDIR"
ln -s $REAL_DYNDIR $BASEDIR/dyn && echo ' done.'


#copy base files
echo -n "Copying files"
cp $nupyf_conf $BASEDIR/desc
cp doc/$acls_ex $nuface_datadir
cp doc/$desc_ex $BASEDIR/desc
cp $fw_script /etc/init.d/
echo " done"

#make www-data able to write directories and files
echo 'Fixing files an directories permissions'
chown $www_user $REAL_DYNDIR
chown $www_user $nuface_datadir
chown $www_user $nuface_datadir/$acls_ex
chown $www_user $nuface_logdir

echo "


-----------------------------
Configuration done.

Now please:
 - edit /etc/sudoers, see INSTALL
 - edit nuface configuration file if you need it
 - install nuface files as described in INSTALL
 - install nupyf files as described in INSTALL
------------------------------
"

	
